#!/usr/bin/python3
#-*- coding: utf-8 -*-

from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
from matplotlib import cm
from matplotlib.ticker import LinearLocator, FormatStrFormatter
import numpy as np
    
##----------------------------------
#  Affichage 1D :        
def afficher1D(list_x,list_y):
    plt.hold('on')
    plt.plot(list_x[0],list_y[0], '-',linewidth=4.0)
    plt.plot(list_x[1],list_y[1], '--',linewidth=4.0)
    plt.plot(list_x[2],list_y[2], 'x',linewidth=4.0)
    
    plt.legend(["pn","f","f(x_i)"])
    plt.show()
    plt.hold('off')
##----------------------------------    
    
    
##----------------------------------  
#  Affichage 2D :      
def afficherMNT2D(ptX,ptY,Val,ptXB,ptYB,ValB):
    fig = plt.figure()
    ax = fig.gca(projection='3d')
    
    ptX, ptY = np.meshgrid(ptX, ptY)
    # Affichage surface MNT :
    surf = ax.plot_surface(ptX, ptY, Val, cmap=cm.jet, linewidth=0, antialiased=False, shade=False)

    ptXB, ptYB = np.meshgrid(ptXB, ptYB)
    # Affichage data :
    #surf2 = ax.plot_wireframe(ptYB, ptXB, ValB+0.2, linewidth=2, rstride=1, cstride=1)

    plt.show() 
##----------------------------------    


##----------------------------------    
#  Affichage 2D data :  
def afficherMNTData2D(ptX, ptY, Val):
    fig = plt.figure()
    ax = fig.gca(projection='3d')
    
    ptX, ptY = np.meshgrid(ptX, ptY)
    
    # Affichage data :
    surf = ax.plot_wireframe(ptY, ptX, Val, linewidth=2, rstride=1, cstride=1)
    
    plt.show() 
##----------------------------------    
    