#!/usr/bin/python3
#-*- coding: utf-8 -*-

import numpy as np
import copy


##----------------------------------
#  Algorithme de Neville-Aitken cas 2D sur grille cartésienne :
def NevilleAitken2D(PtsEval, PtsInterpX, PtsInterpY, ValPtsInterp):
    nx = len(PtsInterpX)
    EvalX = np.zeros((nx,len(PtsEval[1])))
    
    # Evaluation sur chaque colonne {x = PtsInterpX[i]} 
    for i in range(nx):
        EvalX[i,:] = NevilleAitken(PtsEval[1],PtsInterpY,ValPtsInterp[i,:])
    
    res = np.zeros( (len(PtsEval[1]),len(PtsEval[0])) )  
    # Evaluation sur chaque ligne {y = PtsEval[1][i]}  
    for i,y in enumerate(PtsEval[1]):
        res[i,:] = NevilleAitken(PtsEval[0],PtsInterpX,EvalX[:,i])
        
    return res
##----------------------------------    



##----------------------------------
#  Algorithme de Neville-Aitken : 
def NevilleAitken(PtsEval,PtsInterp,ValPtsInterp):
    nbPts = len(PtsInterp)
    
    #TabNA correspond à la colonne c du tableau de Neville
    # Ici TabNA correspond a une matrice car on applique l'algorithme a plusieurs pts en meme temps (PtsEval est un vecteur)
    TabNA = np.zeros((nbPts,len(PtsEval)))
    # A l'initialisation, TabNA correspond à la colonne c=0
    for i in range(len(PtsEval)):
        TabNA[:,i] = TabNA[:,i] + ValPtsInterp
    #TabNANext correspond à la colonne c+1 du tableau de Neville    
    TabNANext = np.zeros((nbPts,len(PtsEval)))


    # Calcul des colonnes du tableaude Neville :
    for c in range(nbPts-1):
        # Calcul de la colonne c+1 du tableau :
        for l in range(nbPts-c-1):
            pt1 = PtsInterp[l]
            pt2 = PtsInterp[l+c+1]
            # Completer ICI : 
            #TabNANext[l,:] = ...

        # Passage de c à c+1 :    
        TabNA = TabNANext*1.0
        
    return TabNA[0,:]
##----------------------------------



##----------------------------------
#  Algorithme des Differences-Divisées : 
def DiffDiv(PtsInterp,ValPtsInterp):
    nbPts = len(PtsInterp)
    # Liste coefficient base de Newton :
    coeffBN = np.zeros(nbPts)
    # t.q. le polynome d'interpolation soit donné par :
    # pn(x) =  coeffBN[0] + coeffBN[1] (x-x0) + ... + coeffBN[n] (x-x0)...(x-x{n-1})
    
    #TabDD correspond à la colonne c du tableau des DD
    TabDD = np.zeros(nbPts)
    # A l'initialisation, TabDD correspond à la colonne c=0
    TabDD = ValPtsInterp
    #TabNANext correspond à la colonne c+1 du tableau des DD    
    TabDDNext = np.zeros(nbPts)

    #Premier coefficient base Newton :
    coeffBN[0] = TabDD[0]

    # Calcul des colonnes du tableaude DD :
    for c in range(nbPts-1):
        # Calcul de la colonne c+1 du tableau :
        for l in range(nbPts-c-1):
            pt1 = PtsInterp[l]
            # Completer ICI : 
            #pt2 = ...       
            #TabDDNext[l] = ...

        # Passage de c à c+1 :    
        TabDD = TabDDNext*1.0
        # On recupère le coeffcient c+1 de la décomposition dans la base de Newton :
        coeffBN[c+1] = TabDD[0]
           
    return coeffBN
##----------------------------------



##----------------------------------
#  Algorithme de Horner : 
def Horner(coeffBN,PtsInterp, PtsEval):
    nb = len(coeffBN)
    
    # Initialisation
    res = coeffBN[nb-2] + coeffBN[nb-1]*(PtsEval - PtsInterp[nb-2])
    
    # Iterations :
    for i in range(nb-2):
        i
        # Completer ICI :
        #res = ...
    
    return res
##----------------------------------
