#!/usr/bin/python3
#-*- coding: utf-8 -*-

import numpy as np
import affichage

import algo
import data


"""
    Interpolation 1D - 2D pour construire un MNT (Modele Numerique de Terrain)
"""

## ATTENTION : Pour executer le prgm, il faut utiliser python3 ! Donc taper dans un terminal :
# python3 main.py

##----------------------------------
# But du programme :
# 1. Test interpolation fonction 1D.
# 2. Construction du MNT.
butPrgm = 1
print("Que souhaitez vous faire ?")
print(" 1. Test interpolation 1D.")
print(" 2. Construction du MNT (2D).")
butPrgm = input("Entrer le choix : ")

print("")
##----------------------------------


##----------------------------------
# Test Interpolation 1D :
if (butPrgm=="1"):
    
    print("Choix type de points ?")
    print(" 1. Points équirépartis.")
    print(" 2. Points Chebychev.")
    typePt = input("Entrer le choix : ")
    print("")
    
    # Interpolation de la fonction f dans l'intervalle [a,b]
    a=-1.0
    b=1.0
    
    # (N+1) points :
    N = 20
    h = 2.0 / N
    
    ptsInterpRef = []
    if (typePt == "1"):
        ptsInterpRef = np.arange(-1.0,1.0+h,h)
    if (typePt == "2"):
        ptsInterpRef = np.cos( ( np.arange(0.0,N+1.0)*2.0 + 1.0 )*np.pi / (2.0*N+2.0) )  
         
    ptsInterp = ( (np.array(ptsInterpRef)+1.0)*0.5 )*(b-a) + a
    ValPtsInterp = data.f(ptsInterp)   
    
    
    # Evaluation polynome interpolation :    
    absc = np.arange(a,b+0.1*h,0.1*h)
    
    print("Choix méthode évaluation ?")
    print(" 1. Neville-Aitken.")
    print(" 2. Differences Divisées + Horner.")
    metho = input("Entrer le choix : ")
    print("")
    
    ordo = absc*0
    if(metho=="1"):
        ordo = algo.NevilleAitken(absc,ptsInterp,ValPtsInterp)
    if(metho=="2"):
        DD = algo.DiffDiv(ptsInterp,ValPtsInterp)
        ordo = algo.Horner(DD,ptsInterp,absc)
        
    # Affichage resultat :    
    affichage.afficher1D([absc,absc,ptsInterp],[ordo,data.f(absc),data.f(ptsInterp)])    
    
##----------------------------------



##----------------------------------
# Test Interpolation 2D :
if (butPrgm == "2"):
    PtsInterpX = np.arange(-10.0,10.1,5.0)
    PtsInterpY = np.arange(-10.0,10.1,5.0)
    
    # Donnes aux pts d'interpolation :   
    ValPtsInterp = np.genfromtxt("mesure.data", delimiter=",")        
    
    # Grille de mesures :
    EvalPtsX = np.arange(-10.0,10.1,0.1)
    EvalPtsY = np.arange(-10.0,10.1,0.1)
    # Evaluation Polynome interpolation :
    ValPn = algo.NevilleAitken2D([EvalPtsX,EvalPtsY], PtsInterpX, PtsInterpY, ValPtsInterp)
    
    
    # Affichage surface :
    print("Que souhaitez-vous afficher ?")
    print(" 1. Donnees du MNT.")
    print(" 2. MNT reconstruit.")
    choix = input("Entrer le choix : ")
    if (choix=="1"):
        affichage.afficherMNTData2D(PtsInterpX, PtsInterpY, ValPtsInterp)
    if (choix=="2"):
        affichage.afficherMNT2D(EvalPtsX, EvalPtsY, ValPn, PtsInterpX, PtsInterpY, ValPtsInterp)
##----------------------------------


print("FIN \n")
########################################